/*
 * display.h
 *
 *  Created on: 21 avr. 2023
 *      Author: Flax
 */

#ifndef INC_DISPLAY_H_
#define INC_DISPLAY_H_

#include "stdbool.h"
#include "stdint.h"

typedef enum {
	DISP_CHAR_7SEG_0 = 0,
	DISP_CHAR_7SEG_1,
	DISP_CHAR_7SEG_2,
	DISP_CHAR_7SEG_3,
	DISP_CHAR_7SEG_4,
	DISP_CHAR_7SEG_5,
	DISP_CHAR_7SEG_6,
	DISP_CHAR_7SEG_7,
	DISP_CHAR_7SEG_8,
	DISP_CHAR_7SEG_9,
	DISP_CHAR_7SEG_E,
	DISP_CHAR_7SEG_R,
	DISP_CHAR_7SEG_S,
	DISP_CHAR_7SEG_P,
	DISP_CHAR_7SEG_T,
	DISP_CHAR_7SEG_O,
	DISP_CHAR_7SEG_F,
	DISP_CHAR_7SEG_B,
	DISP_CHAR_7SEG_G,
	DISP_CHAR_7SEG_A,
	DISP_CHAR_7SEG_N,
	DISP_CHAR_7SEG_MAX
}e_DISPChar7SegType;

extern void DISPInit (void);
extern void DISPStart (void);
extern void DISPStop (void);

extern  bool DISPSetDisplayDigit (uint8_t digit_u8, char digit_value_u8);

extern void DISPRefresh (void);
extern void DISPEnableDisplay (void);
extern void DISPDisableDisplay (void);

extern void DISPInterruptRx (void);

extern bool DISPUpdateValueNumber (uint16_t value_U16);
extern void DISPUpdateDigit (uint8_t digit_U8, e_DISPChar7SegType char_E);

#endif /* INC_DISPLAY_H_ */
