/*
 * temperatureRegulation.h
 *
 *  Created on: Apr 16, 2023
 *      Author: Flax
 */

#ifndef INC_TEMPERATUREREGULATION_H_
#define INC_TEMPERATUREREGULATION_H_

// ===============
// Shared includes
// ===============
#include "stdbool.h"
#include "stdint.h"

// ================
// Shared constants
// ================

// ===========================
// Shared functions prototypes
// ===========================

extern void REGInit (void);
extern void REGStart (void);
extern void REGStop (void);
extern void REGCyclicTask (void);

extern bool REGIsError(void);
extern bool REGIsStandby(void);
extern bool REGIsOff(void);

extern void REGErrorReset(void);
extern void REGStandbySet(void);
extern void REGStandbyReset(void);
extern void REGOffSet(void);
extern void REGOffReset(void);

extern bool REGSPTSet (uint16_t temp_spt_u16);
extern uint16_t REGSPTGet (void);

extern bool REGSPTStbySet (uint16_t temp_spt_u16);
extern uint16_t REGSPTStbyGet (void);

extern uint16_t REGTempGet (void);
extern uint16_t REGTempPhysDeg (void);

#endif /* INC_TEMPERATUREREGULATION_H_ */
