/*
 * mainAppli.c
 *
 *  Created on: Apr 16, 2023
 *      Author: Flax
 *
 *      Prefix : MAIN
 */


// ==============
// Local includes
// ==============
#include "hmi.h"
#include "temperatureRegulation.h"
#include "save.h"

// DEBUG
#include "stm32l0xx_ll_gpio.h"

// ===============
// Local constants
// ===============
// DEBUG
static uint32_t cnt_u32;

// ==========================
// Local functions prototypes
// ==========================

// ===========================
// Local functions definitions
// ===========================

// ============================
// Shared functions definitions
// ============================

void MAINInit (void)
{
	HMIInit();
	REGInit();
	SAVInit();
}

void MAINStart (void)
{
	HMIStart();
	REGStart();
	SAVStart();
}

void MAINStop (void)
{
	SAVStop();
	REGStop();
	HMIStop();
}

void MAINCyclicTask (void)
{
	HMICyclicTask();
	REGCyclicTask();
	SAVCyclicTask();

	if (cnt_u32 < 1000)
	{
		cnt_u32++;
	}
	else
	{
		cnt_u32 = 0;
		LL_GPIO_TogglePin(GPIOB, LL_GPIO_PIN_1);
	}
}
